VERSION 5.00
Begin VB.UserControl VScroller 
   ClientHeight    =   2640
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   510
   ScaleHeight     =   2640
   ScaleWidth      =   510
   Begin VB.VScrollBar VScroll1 
      Height          =   2175
      LargeChange     =   100
      Left            =   120
      Max             =   1000
      SmallChange     =   20
      TabIndex        =   0
      Top             =   180
      Width           =   255
   End
End
Attribute VB_Name = "VScroller"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const CellName = "VScrollData"

'----------------------------
Private Sub VScroll1_Change()
'----------------------------
Dim AShape As Visio.Shape
Dim Factor As Single
  On Error Resume Next ' so our control doesn't crash
  Set AShape = UserControl.Ambient.Shape
  CheckHasOneConnPt AShape
  Factor = (VScroll1.Value - VScroll1.Min) / (VScroll1.Max - VScroll1.Min)
  AShape.Cells("Connections.X1").Formula = "Width"
  AShape.Cells("Connections.Y1").Formula = "Height * (1 - " + Format(Factor) + ")"
  
  SaveVScrollData AShape, VScroll1.Value
End Sub

'----------------------------
Private Sub CheckHasOneConnPt(AShape As Visio.Shape)
'----------------------------
Dim ConnPtCount As Integer
  On Error Resume Next
  AShape.AddSection visSectionConnectionPts
  
  ConnPtCount = AShape.RowCount(visSectionConnectionPts)
  If ConnPtCount = 0 Then
    AShape.AddRow visSectionConnectionPts, visRowFirst, 0
  End If
End Sub

'----------------------------
Private Sub SaveVScrollData(AShape As Visio.Shape, V As Integer)
'----------------------------
Dim ACell As Visio.Cell
  On Error Resume Next
  Set ACell = AShape.Cells("User." + CellName)
  If ACell Is Nothing Then
    AShape.AddNamedRow visSectionUser, CellName, 0
    Set ACell = AShape.Cells("User." + CellName)
  End If
  ACell.Formula = "=" + Format(V)
End Sub

'---------------------------------
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
'---------------------------------
Dim AShape As Visio.Shape
Dim ACell As Visio.Cell
  On Error Resume Next
  Set AShape = UserControl.Ambient.Shape
  Set ACell = AShape.Cells("User." + CellName)
  If Not (ACell Is Nothing) Then
    VScroll1.Value = ACell.Result(0)
  End If
End Sub

'---------------------------------
Private Sub UserControl_Resize()
'---------------------------------
  VScroll1.Height = UserControl.Height * 0.8
  VScroll1.Width = UserControl.Width * 0.8
  
  VScroll1.Left = UserControl.Width * 0.1
  VScroll1.Top = UserControl.Height * 0.1
End Sub


